//+------------------------------------------------------------------+
//|                                                    Ost_K_P_D.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 PaleGreen
#property indicator_color2 Goldenrod
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_level1  0
//---- input parameters
extern int fast   = 3;
extern int slow   = 6;
extern int AvBars = 88;
extern int CountBars = 555;
//---- buffers 
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer01[];
double Buffer02[];
double AvMax[];
double AvMin[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
//---- 1 additional buffer used for counting.
   IndicatorBuffers(8);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buffer01);
   SetIndexDrawBegin(0,Bars-CountBars+30);
   SetIndexLabel(0,"speed KPD");
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer02);
   SetIndexDrawBegin(1,Bars-CountBars+30);
   SetIndexLabel(1,"KPD");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Buffer3);
   SetIndexDrawBegin(2,Bars-CountBars+30);
   SetIndexStyle(3,DRAW_LINE,2,0);
   SetIndexBuffer(3,Buffer4);
   SetIndexDrawBegin(3,Bars-CountBars+30);
   SetIndexBuffer(4,Buffer1);
   SetIndexBuffer(5,Buffer2);
   SetIndexBuffer(6,AvMax);
   SetIndexBuffer(7,AvMin);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bears Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int i, nLimit, nCountedBars;  
//---- insufficient data
   if(Bars <= AvBars) 
       return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars = IndicatorCounted();
//----Williams Percent Range calculation
   i = Bars - AvBars - 1;
   if(nCountedBars > AvBars) 
       i = Bars - nCountedBars - 1;  
 while(i >= 0)
  {     
       Buffer1[i]=P_V_mx( i,fast);                          
       Buffer2[i] =P_V_mx( i,slow);   
       Buffer3[i] =  countAvMax(i);                    
       Buffer4[i] =  countAvMin(i);
       i--;

  }
//----
   i=Bars-nCountedBars -1;
   while(i>=0)
     {
             Buffer01[i]=iMAOnArray(Buffer1,0,fast,0,MODE_SMA,i);
      
             Buffer02[i]=iMAOnArray(Buffer2,0,fast,0,MODE_SMA,i);
      i--;
     }                                                           
   return(0);
}
//+------------------------------------------------------------------+
double P_V_mx(int i,int channal_p)
{  
   double nv = 0.0;
    for (int j = i; j < (i+channal_p); j++) 
  {
    double mx = (Close[j]-Open[j]);
    nv =nv+mx/Point;
  }
  return (nv);
}
double max_c_o(int i,int channal_p)
{  
   double nv = -1000000.0;
   double mx = 0.0;
    for (int j = i; j < (i+channal_p); j++) 
  {
    nv =+ Buffer1[j];
    if(nv >= mx) mx = nv ;
  }
   return (mx);
}
double min_c_o(int i,int channal_p)
{  
   double nv = 0.0;
   double mn = 1000000.0;
    for (int j = i; j < (i+channal_p); j++) 
  {
    nv =+ Buffer1[j];
    if(nv <= mn) mn = nv ;
  }
   return (mn);
}
double Volum(int i,int slow)
{
   double nv = 0.0;
   for (int j = i; j < (i+slow); j++) nv = nv +  Volume[j];
   nv = nv / slow;
   return (nv);
}
double countAvMax(int j)
{
   int i;
   double cnt = 0.0, m = 0.0;
   
   for(i=j+2; i<=j+AvBars; i++)
   {
      if(Buffer2[i]>Buffer2[i+1] && Buffer2[i]>Buffer2[i-1])    //SignalBuffer[i] -  . MAX
      {
         m+=Buffer2[i];
         cnt++;
      }
   }      
   if(cnt>0.0) return(NormalizeDouble(m/cnt,Digits));
   else return(AvMax[i+1]);
}

double countAvMin(int j)
{
   int i;
   double cnt = 0.0, m = 0.0;
   
   for(i=j+2; i<=j+AvBars; i++)
   {
      if(Buffer2[i]<Buffer2[i+1] && Buffer2[i]<Buffer2[i-1])    //SignalBuffer[i] -  . MIN
      {
         m+=Buffer2[i];
         cnt++;
      }
   }      
   if(cnt>0.0) return(NormalizeDouble(m/cnt,Digits));
   else return(AvMin[i+1]);
}



